"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _excluded = ["children", "limit", "ellipsis"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Badge = (0, _react.forwardRef)(function (_ref, ref) {
  var _ref$children = _ref.children,
      children = _ref$children === void 0 ? '0' : _ref$children,
      _ref$limit = _ref.limit,
      limit = _ref$limit === void 0 ? 2 : _ref$limit,
      _ref$ellipsis = _ref.ellipsis,
      ellipsis = _ref$ellipsis === void 0 ? '+' : _ref$ellipsis,
      others = _objectWithoutPropertiesLoose(_ref, _excluded);

  // 标题
  var caption = children;

  if (limit && children && (typeof children === 'string' || typeof children === 'number')) {
    // 数字大于99,则显示99+
    if (!isNaN(children)) {
      caption = children.length > limit ? '99999'.substring(0, limit) + ellipsis : children;
    } else {
      caption = children.length > limit ? children.substring(0, limit) + ellipsis : children;
    }
  }

  return /*#__PURE__*/_react["default"].createElement("span", _extends({
    ref: ref
  }, others, {
    className: "badge" + (others.className ? ' ' + others.className : '')
  }), caption);
});
var _default = Badge;
exports["default"] = _default;
module.exports = exports.default;