"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _instance = _interopRequireDefault(require("./instance.js"));

var _excluded = ["style", "className", "slideAttribute", "pagination", "paginationAttribute", "prevAttribute", "nextAttribute", "stopPropagation", "activeIndex", "loop", "autoPlay", "slidesPerView", "defaultSrc", "list", "enableOnChange", "speed", "onClick", "onChange", "delay", "children"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Carrousel = (0, _react.forwardRef)(function (_ref, ref) {
  var style = _ref.style,
      className = _ref.className,
      _ref$slideAttribute = _ref.slideAttribute,
      slideAttribute = _ref$slideAttribute === void 0 ? {} : _ref$slideAttribute,
      _ref$pagination = _ref.pagination,
      pagination = _ref$pagination === void 0 ? false : _ref$pagination,
      _ref$paginationAttrib = _ref.paginationAttribute,
      paginationAttribute = _ref$paginationAttrib === void 0 ? {} : _ref$paginationAttrib,
      _ref$prevAttribute = _ref.prevAttribute,
      prevAttribute = _ref$prevAttribute === void 0 ? {} : _ref$prevAttribute,
      _ref$nextAttribute = _ref.nextAttribute,
      nextAttribute = _ref$nextAttribute === void 0 ? {} : _ref$nextAttribute,
      _ref$stopPropagation = _ref.stopPropagation,
      stopPropagation = _ref$stopPropagation === void 0 ? false : _ref$stopPropagation,
      activeIndex = _ref.activeIndex,
      _ref$loop = _ref.loop,
      loop = _ref$loop === void 0 ? false : _ref$loop,
      _ref$autoPlay = _ref.autoPlay,
      autoPlay = _ref$autoPlay === void 0 ? 0 : _ref$autoPlay,
      _ref$slidesPerView = _ref.slidesPerView,
      slidesPerView = _ref$slidesPerView === void 0 ? 1 : _ref$slidesPerView,
      _ref$defaultSrc = _ref.defaultSrc,
      defaultSrc = _ref$defaultSrc === void 0 ? '//res.waiqin365.com/d/seedsui/carrousel/default.png' : _ref$defaultSrc,
      _ref$list = _ref.list,
      list = _ref$list === void 0 ? [] : _ref$list,
      _ref$enableOnChange = _ref.enableOnChange,
      enableOnChange = _ref$enableOnChange === void 0 ? true : _ref$enableOnChange,
      _ref$speed = _ref.speed,
      speed = _ref$speed === void 0 ? 300 : _ref$speed,
      onClick = _ref.onClick,
      onChange = _ref.onChange,
      _ref$delay = _ref.delay,
      delay = _ref$delay === void 0 ? 500 : _ref$delay,
      children = _ref.children,
      others = _objectWithoutPropertiesLoose(_ref, _excluded);

  var refEl = (0, _react.useRef)(null);
  (0, _react.useImperativeHandle)(ref, function () {
    return refEl.current;
  });

  var childrenArr = _react["default"].Children.toArray(children);

  childrenArr = childrenArr.filter(function (child) {
    if (typeof child !== 'object') return false;
    return true;
  });
  var instance = (0, _react.useRef)(null);

  function slideToIndex(currentSpeed) {
    if (!instance || !instance.current) return; // 设置选中项

    var len = childrenArr.length || (list || []).length;

    if (typeof activeIndex === 'number' && activeIndex <= len - 1) {
      instance.current.slideTo(activeIndex, typeof currentSpeed === 'number' ? currentSpeed : speed, false);
    }
  }

  function update() {
    if (!instance.current || !instance.current.updateParams) return;
    instance.current.activeIndex = activeIndex;
    instance.current.updateParams({
      height: style && style.height ? style.height : null,
      width: style && style.width ? style.width : null,
      stopPropagation: stopPropagation,
      autoplay: autoPlay,
      slidesPerView: slidesPerView,
      loop: loop,
      imgLoadSrc: defaultSrc
    });
  }

  (0, _react.useEffect)(function () {
    // 只有list或children发生变化时才更新
    update();
  }, [list, children]); // eslint-disable-line

  (0, _react.useEffect)(function () {
    slideToIndex();
  }, [activeIndex]); // eslint-disable-line

  (0, _react.useEffect)(function () {
    if (!refEl || !refEl.current) return;
    instance.current = new _instance["default"](refEl.current, {
      height: style && style.height ? style.height : null,
      width: style && style.width ? style.width : null,
      stopPropagation: stopPropagation,
      autoplay: autoPlay,
      slidesPerView: slidesPerView,
      loop: loop,
      imgLoadSrc: defaultSrc,
      onClick: click,
      onSlideChangeEnd: onChange ? onChange : null
    }); // 轮播图片, 自适应的情况下, 高度需要计算

    if (!(style && style.height) && list.length && delay) {
      setTimeout(function () {
        instance.current.updateContainerSize();

        if (typeof activeIndex === 'number' && activeIndex > 0) {
          slideToIndex(0);
        }
      }, delay);
    } else {
      if (typeof activeIndex === 'number' && activeIndex > 0) {
        slideToIndex(0);
      }
    }
  }, []); // eslint-disable-line
  // 更新句柄, 防止synchronization模式, 每次组件在render的时候都生成上次render的state、function、effects

  if (instance.current) {
    instance.current.params.onClick = click;
    instance.current.params.onSlideChangeEnd = onChange;
  } // 点击轮播


  function click(s) {
    var index = s.activeIndex;
    if (onClick) onClick(s, list[index], index);
  } // 如果className没有carrousel-container或者carrousel-page, 则补充一个


  function getCarrouselClassName() {
    if (className) {
      if (className.indexOf('carrousel-container') !== -1 || className.indexOf('carrousel-page') !== -1) {
        return className;
      }
    }

    return 'carrousel-container' + (className ? ' ' + className : '');
  } // 如果项中包含bg属性, 则加入到style中


  function getSlideStyle(item) {
    if (item.bg) {
      return Object.assign({
        backgroundImage: "url(" + (defaultSrc ? defaultSrc : item.bg) + ")"
      }, slideAttribute.style);
    }

    return slideAttribute.style;
  }

  return /*#__PURE__*/_react["default"].createElement("div", _extends({
    ref: refEl,
    className: getCarrouselClassName(),
    style: style
  }, others), /*#__PURE__*/_react["default"].createElement("div", {
    className: "carrousel-wrapper"
  }, list.length > 0 && list.map(function (item, index) {
    return /*#__PURE__*/_react["default"].createElement("div", _extends({}, slideAttribute, {
      className: "carrousel-slide" + (slideAttribute.className ? ' ' + slideAttribute.className : ''),
      style: getSlideStyle(item),
      key: index,
      "data-load-src": defaultSrc ? item.bg : null
    }), item.img && /*#__PURE__*/_react["default"].createElement("img", {
      className: "carrousel-slide-img",
      alt: "",
      src: defaultSrc ? defaultSrc : item.img,
      "data-load-src": defaultSrc ? item.img : null
    }), item.caption && /*#__PURE__*/_react["default"].createElement("div", {
      className: "carrousel-summary"
    }, item.iconAttribute && /*#__PURE__*/_react["default"].createElement("i", _extends({}, item.iconAttribute, {
      className: "icon carrousel-summary-icon" + (item.iconAttribute.className ? ' ' + item.iconAttribute.className : '')
    })), /*#__PURE__*/_react["default"].createElement("span", {
      className: "nowrap carrousel-summary-caption",
      style: {
        marginRight: '20px'
      }
    }, item.caption)));
  }), list.length === 0 && childrenArr && childrenArr.map(function (item, index) {
    return /*#__PURE__*/_react["default"].createElement("div", _extends({}, slideAttribute, {
      className: "carrousel-slide" + (slideAttribute.className ? ' ' + slideAttribute.className : ''),
      key: index
    }), item);
  })), pagination === true && /*#__PURE__*/_react["default"].createElement("div", _extends({}, paginationAttribute, {
    className: "carrousel-pagination" + (paginationAttribute.className ? ' ' + paginationAttribute.className : '')
  })), pagination && pagination !== true && pagination, list.length > 1 && /*#__PURE__*/_react["default"].createElement("div", _extends({}, prevAttribute, {
    className: "carrousel-prev" + (prevAttribute.className ? ' ' + prevAttribute.className : '')
  })), list.length > 1 && /*#__PURE__*/_react["default"].createElement("div", _extends({}, nextAttribute, {
    className: "carrousel-next" + (nextAttribute.className ? ' ' + nextAttribute.className : '')
  })));
});
var _default = Carrousel;
exports["default"] = _default;
module.exports = exports.default;