"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _excluded = ["type", "value", "checked", "disabled", "inputAttribute", "caption", "captionAttribute", "onClick"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Checkbox = (0, _react.forwardRef)(function (_ref, ref) {
  var type = _ref.type,
      value = _ref.value,
      checked = _ref.checked,
      disabled = _ref.disabled,
      _ref$inputAttribute = _ref.inputAttribute,
      inputAttribute = _ref$inputAttribute === void 0 ? {} : _ref$inputAttribute,
      caption = _ref.caption,
      _ref$captionAttribute = _ref.captionAttribute,
      captionAttribute = _ref$captionAttribute === void 0 ? {} : _ref$captionAttribute,
      onClick = _ref.onClick,
      others = _objectWithoutPropertiesLoose(_ref, _excluded);

  function clickHandler(e, isChecked) {
    if (disabled) return;
    if (onClick) onClick(e, isChecked);
  }

  var typeClassPrefix = type === 'radio' ? 'radio' : 'checkbox';
  return /*#__PURE__*/_react["default"].createElement("div", _extends({
    ref: ref
  }, others, {
    onClick: function onClick(e) {
      clickHandler(e, e.target.getAttribute('data-checked') === 'true');
    },
    disabled: disabled,
    "data-checked": checked,
    "data-value": value,
    className: "" + typeClassPrefix + (others.className ? ' ' + others.className : '')
  }), /*#__PURE__*/_react["default"].createElement("span", _extends({}, inputAttribute, {
    className: typeClassPrefix + "-input" + (inputAttribute.className ? ' ' + inputAttribute.className : '')
  })), caption && /*#__PURE__*/_react["default"].createElement("span", _extends({}, captionAttribute, {
    className: typeClassPrefix + "-caption" + (captionAttribute.className ? ' ' + captionAttribute.className : '')
  }), caption));
});
var _default = Checkbox;
exports["default"] = _default;
module.exports = exports.default;