"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _Star = _interopRequireDefault(require("./../Star"));

var _instance = _interopRequireDefault(require("../Context/instance.js"));

var _excluded = ["min", "max", "value", "onChange", "onError"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var InputStar = (0, _react.forwardRef)(function (_ref, ref) {
  var _ref$min = _ref.min,
      min = _ref$min === void 0 ? 0 : _ref$min,
      _ref$max = _ref.max,
      max = _ref$max === void 0 ? 5 : _ref$max,
      _ref$value = _ref.value,
      value = _ref$value === void 0 ? 0 : _ref$value,
      onChange = _ref.onChange,
      onError = _ref.onError,
      others = _objectWithoutPropertiesLoose(_ref, _excluded);

  // context
  var context = (0, _react.useContext)(_instance["default"]) || {};

  var locale = context.locale || function (remark) {
    return remark || '';
  };

  function changeHandler(e, argNum) {
    var num = argNum;

    if (num < min) {
      if (onError) {
        onError(e, {
          errMsg: "" + locale('不能小于', 'hint_cannot_be_less_than') + min + locale('颗星', 'star'),
          select: num,
          min: min,
          value: min,
          event: e
        });
      }

      num = min;
    }

    if (onChange) onChange(e, num);
  }

  var stars = [];

  for (var i = 1; i <= max; i++) {
    stars.push(i);
  }

  var current = value;
  if (current < min) current = min;
  return /*#__PURE__*/_react["default"].createElement("div", _extends({
    ref: ref
  }, others, {
    className: "input-star" + (others.className ? ' ' + others.className : '')
  }), stars.map(function (index) {
    return /*#__PURE__*/_react["default"].createElement(_Star["default"], {
      onClick: function onClick(e) {
        changeHandler(e, index);
      },
      key: index,
      className: index <= current ? 'active' : ''
    });
  }));
});
var _default = InputStar;
exports["default"] = _default;
module.exports = exports.default;