"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactDom = require("react-dom");

var _locale = _interopRequireDefault(require("./../locale"));

var _excluded = ["portal", "type", "maskAttribute", "iconAttribute", "captionAttribute", "children", "caption"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

// 国际化数据
var Loading = (0, _react.forwardRef)(function (_ref, ref) {
  var portal = _ref.portal,
      _ref$type = _ref.type,
      type = _ref$type === void 0 ? 'floating' : _ref$type,
      _ref$maskAttribute = _ref.maskAttribute,
      maskAttribute = _ref$maskAttribute === void 0 ? {} : _ref$maskAttribute,
      iconAttribute = _ref.iconAttribute,
      _ref$captionAttribute = _ref.captionAttribute,
      captionAttribute = _ref$captionAttribute === void 0 ? {} : _ref$captionAttribute,
      children = _ref.children,
      _ref$caption = _ref.caption,
      caption = _ref$caption === void 0 ? (0, _locale["default"])('加载中...', 'loading') : _ref$caption,
      others = _objectWithoutPropertiesLoose(_ref, _excluded);

  var content = null;

  if (type === 'custom') {
    // 自定义样式
    content = /*#__PURE__*/_react["default"].createElement("div", _extends({}, others, {
      className: "loading-custom" + (others.className ? ' ' + others.className : '')
    }), iconAttribute && /*#__PURE__*/_react["default"].createElement("span", _extends({}, iconAttribute, {
      className: "loading-custom-icon" + (iconAttribute.className ? ' ' + iconAttribute.className : '')
    })), caption && /*#__PURE__*/_react["default"].createElement("p", _extends({}, captionAttribute, {
      className: "loading-custom-caption" + (captionAttribute.className ? ' ' + captionAttribute.className : '')
    }), caption));
  } else if (type === 'filling') {
    // 填料环
    content = /*#__PURE__*/_react["default"].createElement("div", _extends({}, others, {
      className: "loading-filling active" + (others.className ? ' ' + others.className : '')
    }), /*#__PURE__*/_react["default"].createElement("div", {
      className: "loading-filling-icon"
    }));
  } else if (type === 'floating') {
    // 流光
    content = /*#__PURE__*/_react["default"].createElement("div", _extends({}, others, {
      className: "loading-floating animated" + (others.className ? ' ' + others.className : '')
    }), /*#__PURE__*/_react["default"].createElement("div", {
      className: "loading-floating-icon"
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/_react["default"].createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/_react["default"].createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/_react["default"].createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/_react["default"].createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/_react["default"].createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/_react["default"].createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/_react["default"].createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/_react["default"].createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/_react["default"].createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/_react["default"].createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/_react["default"].createElement("div", {
      className: "loading-floating-blade"
    })), caption && /*#__PURE__*/_react["default"].createElement("div", _extends({}, captionAttribute, {
      className: "loading-floating-caption" + (captionAttribute.className ? ' ' + captionAttribute.className : '')
    }), caption));
  }

  if (portal) {
    return (0, _reactDom.createPortal)( /*#__PURE__*/_react["default"].createElement("div", _extends({
      ref: ref
    }, maskAttribute, {
      className: 'loading-mask mask active' + (maskAttribute.className ? ' ' + maskAttribute.className : '')
    }), content, children), portal);
  }

  return /*#__PURE__*/_react["default"].createElement("div", _extends({
    ref: ref
  }, maskAttribute, {
    className: 'loading-mask mask active' + (maskAttribute.className ? ' ' + maskAttribute.className : '')
  }), content, children);
});
var _default = Loading;
exports["default"] = _default;
module.exports = exports.default;